// ---------------------------------------------------------------------------------------
// File Name    : WTLeak.cpp
// Created      : 27.11.2013 by Bogdan Cosescu
// Description  : 
// ---------------------------------------------------------------------------------------

#include <Wt/WServer>
#include <Wt/WApplication>
#include <Wt/WContainerWidget>
#include "MyApplication.h"
#include "CanvasWidget.h"

using namespace Wt;

//create app callback
WApplication *createApplication(const WEnvironment& env)
{
    CMyApplication *pApp = new CMyApplication(env);

    CCanvasWidget* pCanvas = new CCanvasWidget();
    pApp->root()->addWidget(pCanvas);
    return pApp;
}

int main(int argc, char **argv)
{
    try
    {
        WServer server;

        server.setServerConfiguration(argc, argv, "../start.cfg");

        server.addEntryPoint(Application, createApplication);

        if (server.start())
        {
            WServer::waitForShutdown();
            server.stop();
        }
    }
    catch (WServer::Exception& e)
    {
        std::cerr << e.what() << std::endl;
    }
    catch (std::exception &e)
    {
        std::cerr << "exception: " << e.what() << std::endl;
    }
}